######################################################################
#Medidas de posicao x medidas de dispersao

# A=rnorm(100,60,2)
# A=round(A)
# summary(A)
# B=rnorm(100,60,7)
# B=round(B)
# summary(B)
# C=rnorm(100,60,15)
# C=round(C)
# summary(C)



#C=c(67,56,67,42,55,75,51,82,42,55,36,58,59,28,39,45,59,66,74,75,94,43,36,48,74
#,79,67,69,61,54,46,51,60,82,41,52,46,50,53,53,67,66,71,53,34,70,38,59,41,41
#,71,55,70,69,43,58,60,89,49,56,59,56,42,63,88,70,53,98,79,46,21,32,44,58,44
#,77,79,58,67,64,40,60,44,80,44,48,38,50,64,49,80,49,68,67,78,36,77,61,75,43)
#C=rnorm(100,60,15)
#amostra=sample(1:60,rep=TRUE)
#C=trunc(C)
#C=C[amostra]

A=c(58, 61, 60, 62, 61, 62, 59, 59, 64, 57, 57, 60, 59, 61, 59,
    61, 58, 63, 58, 61, 55, 61, 58, 60, 59, 63, 59, 58, 58, 58,
    59, 59, 59, 61, 62, 59, 62, 57, 56, 62, 57, 62, 58, 62, 61,
    54, 62, 60, 56, 63, 61, 60, 62, 59, 63, 59, 64, 57, 60, 59,
    58, 65, 58, 60, 60, 60, 59, 60, 61, 64, 59, 64, 63, 62, 60,
    58, 58, 59, 61, 59, 62, 62, 61, 60, 61, 61, 58, 61, 66, 57,
    63, 59, 60, 60, 61, 63, 55, 61, 59, 60)


B=c(54,60,65,67,49,51,64,64,53,58,70,59,69,52,65,65,75,75,65,62,60,65,79,54,62
    ,61,64,59,58,41,50,64,54,73,58,65,60,55,61,54,46,56,81,64,55,67,68,63,54,69
    ,40,48,67,64,60,50,56,62,65,62,66,59,59,62,66,57,63,66,69,43,62,58,52,64,61
    ,57,68,65,58,52,51,53,54,63,53,65,52,54,47,73,61,64,56,45,66,50,50,63,62,46)

C=c(93, 39, 77, 75, 76, 49, 63, 58, 48, 57, 63, 76, 38, 76, 42, 57, 58, 63, 57, 63, 46, 46, 57, 83, 49,
69, 37, 38, 46, 77, 57, 64, 58, 63, 75, 48, 40, 38, 72, 39, 72, 59, 76, 46, 54, 43, 66, 66, 63, 72,
37, 76, 78, 66, 67, 63, 63, 66, 57, 54)


prova1=data.frame(notas=c(A,B,C),turma=c(rep('A',100),rep('B',100),rep('C',60)))


require('BHH2')
par(mfrow=c(3,1))
dotPlot(A,xlim=range(c(A,B,C)),xlab='Notas-Turma A')
dotPlot(B,xlim=range(c(A,B,C)),xlab='Notas-Turma B')
dotPlot(C,xlim=range(c(A,B,C)),xlab='Notas-Turma C')

hist(A,xlim=range(c(A,B,C)),xlab='Notas',breaks=seq(0,100,by=10),main='Turma A')
hist(B,xlim=range(c(A,B,C)),xlab='Notas',breaks=seq(0,100,by=10),main='Turma B')
hist(aux,xlim=range(c(A,B,C)),xlab='Notas',breaks=seq(0,100,by=10),main='Turma C')


#medidas de tendencia central
A[order(A)]
B[order(B)]
C[order(C)]


round(summary(A))
round(summary(B))
round(summary(C))


par(mfrow=c(1,1))
with(prova1,boxplot(notas~turma,xlab='Turmas',ylab='Notas',range=0,col=5,ylim=c(0,100)))
with(prova1,boxplot(notas~turma,xlab='NOTAS',ylab='TURMAS',range=0,col=5,horizontal=TRUE,ylim=c(0,100)))

#by(prova1$notas,prova1$turma,summary)


#medidas de dispersao

#amplitude inter-quartis
require('BHH2')
par(mfrow=c(3,1))
dotPlot(A,xlim=range(c(A,B,C)),xlab='Notas-Turma A')
abline(v=59,col=2)
abline(v=60,col=2)
abline(v=61,col=2)
dotPlot(B,xlim=range(c(A,B,C)),xlab='Notas-Turma B')
abline(v=54,col=2)
abline(v=61,col=2)
abline(v=65,col=2)
dotPlot(C,xlim=range(c(A,B,C)),xlab='Notas-Turma C')
abline(v=48,col=2)
abline(v=61,col=2)
abline(v=70,col=2)

#outra medida de dispersao = variancia
dist1=A-mean(A)
dist2=B-mean(B)
dist3=C-mean(C)

mean(dist1)
mean(dist2)
mean(dist3)

sum(dist1^2)/100
sum(dist2^2)/100
sum(dist3^2)/60

# desvio-padrao
sqrt(sum(dist1^2)/100)
sqrt(sum(dist2^2)/100)
sqrt(sum(dist3^2)/60)


#TEOREMA DE TCHEBICHEV: pelo menos 75% das observações estão entre (media-2 x dp; media+2 x dp)
li=mean(A)-2*sd(A)
ls=mean(A)+2*sd(A)
sum(A>=li&A<=ls)/100

li=mean(B)-2*sd(B)
ls=mean(B)+2*sd(B)
sum(B>=li&B<=ls)/100

li=mean(C)-2*sd(C)
ls=mean(C)+2*sd(C)
sum(C>=li&C<=ls)/60

#pelo menos 89% das observações estão entre (media-3 x dp; media+3 x dp)


#medida de homogeneidade das observações = CV
sd(A)/mean(A)
sd(B)/mean(B)
sd(C)/mean(C)



#medida de desempenho individual = escore padronizado
par(mfrow=c(3,1))
dotPlot(round(A),xlim=range(c(A,B,C)),xlab='Notas-Turma A')
abline(v=66,lty=2,col=2)
dotPlot(round(B),xlim=range(c(A,B,C)),xlab='Notas-Turma B')
abline(v=66,lty=2,col=2)
dotPlot(round(C),xlim=range(c(A,B,C)),xlab='Notas-Turma C')
abline(v=66,lty=2,col=2)

round(summary(A))
round(summary(B))
round(summary(C))

66-mean(A)
66-mean(B)
66-mean(C)

(66-mean(A))/sd(A)
(66-mean(B))/sd(B)
(66-mean(C))/sd(C)

########
# Mostrando porque é melhor usar n-1 ao invés de n 
# ao estimar a variância
tempo=rweibull(20000,1.5,0.5)
par(mfrow=c(1,1))
hist(tempo)
var.pop=round(sum((tempo-mean(tempo))^2)/20000,3)
n=10
amostra=sample(tempo,size=n,replace=TRUE)
var.10=round(sum((amostra-mean(amostra))^2)/10,3)
var.9=round(sum((amostra-mean(amostra))^2)/9,3)
data.frame(var.pop, var.10, var.9)

m=NULL
v=NULL
vv=NULL
n=10
for (i in 1:250) {
  amostra=sample(tempo,size=n,replace=TRUE)
  m=c(m,mean(amostra))
  vv=c(vv,sum((amostra-mean(amostra))^2)/n)
  v=c(v,sum((amostra-mean(amostra))^2)/(n-1))
}

require('BHH2')

par(mfrow=c(2,1))
dotPlot(v,xlab='Variância com denominador (n-1)',xlim=range(c(v,vv)))
abline(v=var.pop,col=2,lwd=3)
abline(v=mean(v),col=4,lwd=3)
legend(max(vv)-0.1,1,c('Var. pop.','Var. (denom. n-1)'), col=c(2,4),lty=1,lwd=3)
dotPlot(vv,xlab='Variância com denominador (n)',xlim=range(c(v,vv)))
abline(v=var.pop,col=2,lwd=3)
abline(v=mean(vv),col=4,lwd=3)
legend(max(vv)-0.1,1,c('Var. pop.','Var. (denom. n)'), col=c(2,4),lty=1,lwd=3)
